discussion/discussion/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('todolist/', include('todolist.urls')),
    path('admin/', admin.site.urls),
]

discussion/todolist/urls.py
from django.urls import path
# import the views.py from the same folder
from . import views


app_name = 'todolist'

urlpatterns = [
	path('index', views.index, name = 'index'),
	path('<int:todoitem_id>/', views.todoitem, name = "viewtodoitem"),
	path('register', views.register, name = "register"),
	path('change_password', views.change_password, name = "change_password"),
	path('login', views.login_user, name = "login"),
	path('logout', views.logout_user, name = "logout"),
	path('add_task', views.add_task, name = "add_task"),
	path('<int:todoitem_id>/update_task', views.update_task, name="update_task"),
	path('<int:todoitem_id>/delete', views.delete_task, name = "delete_task"),
	path('add_event', views.add_event, name = "add_event"),
	path('event/<int:event_id>/', views.event, name = "viewevent")
]

discussion/todolist/models.py
from django.db import models

# Create your models here.
from django.contrib.auth.models import User

class ToDoItem(models.Model):
	task_name = models.CharField(max_length=50)
	description = models.CharField(max_length=200)
	status = models.CharField(max_length=50, default = "pending")
	date_created = models.DateTimeField('date created')
	user= models.ForeignKey(User, on_delete = models.RESTRICT, default = "")

class Event(models.Model):
	event_name = models.CharField(max_length = 50)
	description = models.CharField(max_length = 200)
	status = models.CharField(max_length = 50, default = "pending")
	event_date = models.CharField(max_length = 30)
	user = models.ForeignKey(User, on_delete = models.RESTRICT, default = "")

discussion/todolist/forms.py
from django import forms

class LoginForm(forms.Form):
	username = forms.CharField(label = "username", max_length = 20)
	password = forms.CharField(label = "password", max_length = 20)

class AddTaskForm(forms.Form):
	task_name = forms.CharField(label = 'task_name', max_length =50)
	description = forms.CharField(label = 'description', max_length = 200)

class UpdateTaskForm(forms.Form):
	task_name = forms.CharField(label = "task_name", max_length = 50 )
	description = forms.CharField(label = "description", max_length = 200)
	status =  forms.CharField(label = "status", max_length =50)

class RegistrationForm(forms.Form):
	username = forms.CharField(label = "username", max_length = 50)
	first_name = forms.CharField(label = "first_name", max_length = 50)
	last_name = forms.CharField(label = "last_name", max_length = 50)
	email = forms.CharField(label = "email", max_length = 50)
	password = forms.CharField(label = "password", max_length = 50)
	confirm_password = forms.CharField(label = "confirm_password", max_length = 50)

class AddEventForm(forms.Form):
	event_name = forms.CharField(label = "event_name", max_length = 50)
	description = forms.CharField(label = "description", max_length = 200)
	event_date = forms.CharField(label = "event_date", max_length = 50)

discussion/todolist/views.py
from django.shortcuts import render, redirect, get_object_or_404

# Create your views here.

# The from keyword allows importing of necessary classes/modules, methods and others files needed in our application from the django.http package while the import keyword defines what we are importing from the package
from django.http import HttpResponse

# Local imports
from .models import ToDoItem, Event

# import the built in User Model
from django.contrib.auth.models import User

# to use the template created:
# from django.template import loader

# import the authenticate function
from django.contrib.auth import authenticate, login, logout

from django.forms.models import model_to_dict

from .forms import LoginForm, AddTaskForm, UpdateTaskForm, RegistrationForm, AddEventForm

from django.utils import timezone

def index(request):

	todoitem_list = ToDoItem.objects.filter(user_id = request.user.id)
	event_list = Event.objects.filter(user_id = request.user.id)

	
	context = {
		'todoitem_list': todoitem_list,
		'event_list': event_list,
		"user": request.user
	}

	# output = ", ".join([todoitem.task_name for todoitem in todoitem_list])
	# render(request, route_template, context)
	return render(request, "index.html", context)

	

def todoitem(request, todoitem_id):
	# response = f"You are viewing the details of {todoitem_id}"
	# return HttpResponse(response)

	todoitem = get_object_or_404(ToDoItem, pk = todoitem_id)

	return render(request, "todoitem.html", model_to_dict(todoitem))



# this function is responsible for registering on our application
def register(request):
	
	context = {}

	users = User.objects.all()

	if request.method == "POST":

		form = RegistrationForm(request.POST)

		if form.is_valid() == False:
			form = RegistrationForm()

		else:

			user = User()

			user.username = form.cleaned_data['username']
			user.set_password(form.cleaned_data['password'])
			user.first_name = form.cleaned_data['first_name']
			user.last_name = form.cleaned_data['last_name']
			user.email = form.cleaned_data['email']
			user.is_staff = False
			user.is_active = True

			is_user_registered = False
			successful = False

			for indiv_user in users:
				if indiv_user.username == user.username:
					is_user_registered = True
					break

			if is_user_registered == False:
				user.save()
				successful = True

			context = {
				'is_user_registered': is_user_registered,
				'first_name': user.first_name,
				'last_name': user.last_name,
				'successful': successful
			}

	return render(request, "register.html", context)

def change_password(request):

	is_user_authenticated = False

	user = authenticate(username = "johndoe", password = "johndoe123456")

	if user is not None:
		authenticated_user = User.objects.get(username = 'johndoe')
		authenticated_user.set_password("johndoe1234567")
		authenticated_user.save()

		is_user_authenticated = True

	context = {
		"is_user_authenticated" : is_user_authenticated
	}

	return render(request, "change_password.html", context)

def login_user(request):
	context = {}

	# if this is a post request we need to process the form data
	if request.method == "POST":

		form = LoginForm(request.POST)

		if form.is_valid() == False:
			form = LoginForm()
			
		else:
			print(form)
			# cleaned_data retrieves the information from the form
			username = form.cleaned_data['username']
			password = form.cleaned_data['password']

			user = authenticate(username = username, password = password)

			if user is not None:
				context = {
					'username' : username,
					'password' : password
				}
				login(request, user)
				return redirect("todolist:index")
			else:
				context = {
					'error' : True
				}
			
	
	return render(request, "login.html", context)








	# username = 'johndoe'
	# password = 'johndoe1234567'

	# user = authenticate(username = username, password = password)

	

def logout_user(request):
	logout(request)
	return redirect("todolist:index")

# Add Task
def add_task(request):
	context = {}

	if request.method == 'POST':
		form = AddTaskForm(request.POST)

		if form.is_valid() == False:
			form = AddTaskForm()

		else:
			task_name = form.cleaned_data['task_name']
			description = form.cleaned_data['description']

			duplicates = ToDoItem.objects.filter(task_name = task_name, user_id = request.user.id)

			if not duplicates:
				# create an ovbject based on the ToDoItem model and saves to the record in the database

				ToDoItem.objects.create(task_name = task_name, description = description, date_created = timezone.now(), user_id = request.user.id)

				return redirect("todolist:index")
			else:
				context = {
					'error' : True
				}

	return render(request, "add_task.html", context)

# Update Task
def update_task(request, todoitem_id):

	todoitem = ToDoItem.objects.filter(pk = todoitem_id)
	print(todoitem)
	context = {
		"user": request.user,
		"todoitem_id": todoitem_id,
		"task_name": todoitem[0].task_name,
		"description": todoitem[0].description,
		"status" : todoitem[0].status
	}

	if request.method == "POST":
		form  = UpdateTaskForm (request.POST)

		if form.is_valid() == False:
			form = UpdateTaskForm()

		else:
			task_name = form.cleaned_data['task_name']
			description = form.cleaned_data['description']
			status = form.cleaned_data['status']

			if todoitem:

				todoitem[0].task_name = task_name
				todoitem[0].description = description
				todoitem[0].status = status

				todoitem[0].save()

				return redirect("todolist:viewtodoitem", todoitem_id =  todoitem[0].id)
			else:

				context = {
					"error" : True
				}

	return render(request, "update_task.html", context)

# Delete Task
def delete_task(request, todoitem_id):

	ToDoItem.objects.filter(pk = todoitem_id).delete()

	return redirect("todolist:index")

# Event
def event(request, event_id):

	event = get_object_or_404(Event, pk = event_id)

	return render(request, "event.html", model_to_dict(event))


# Add Event
def add_event(request):

	context = {}

	if request.method == "POST":
		form = AddEventForm(request.POST)

		if form.is_valid() == False:
			form = AddEventForm()

		else:
			event_name = form.cleaned_data['event_name']
			description = form.cleaned_data['description']
			event_date = form.cleaned_data['event_date']

			duplicates = Event.objects.filter(event_name = event_name, user_id = request.user.id, status = 'pending')

			if not duplicates:

				Event.objects.create(event_name = event_name, description = description, event_date = event_date, user_id = request.user.id)

				return redirect('todolist:index')
			else:
				context = {
					'error': True
				}

	return render(request, "add_event.html", context)

discussion/todolist/templates/add_event.html
{% extends 'base.html' %}

{% block title %}Add Event{% endblock %}

{% block content %}
<div class = "container my-4">
	<h1 class = "text-center">Add Event</h1>
	<div class = "row mt-2">
		<div class = "col-6 offset-3">

			{% if error == True %}
				<p class = "text-danger mt-2">Duplicate/Same Event Found!.</p>
			{% endif %}
			<form action="{% url 'todolist:add_event' %}" method="POST">

                {% csrf_token %}

                <div class="mb-3">
                    <label for="event_name">Event Name: </label>
                    <input 
                    	class="form-control" 
                    	id="event_name" 
                    	type="text" 
                    	name="event_name" 
                    	value="{{event_name}}" 
                    	maxlength="50" 
                    	required
                    	>
                </div>

                <div class="mb-3">
                    <label for="description">Description: </label>
                    <textarea class="form-control" name="description" value="{{description}}" required></textarea>
                </div>

                <div class="mb-3">
                    <label for="event_date">Event Time and Date: </label>
                    <input class="form-control" name="event_date" value="{{event_date}}" placeholder = "DD/MM/YYYY 00:00 AM/PM" maxlength="30" required></textarea>
                </div>

                <div class="text-center">
                    <input 
                    	class="btn btn-success" 
                    	type="submit" 
                    	value="Add Event"
                    	>
                </div>

            </form>
		</div>
	</div>
</div>

{% endblock %}

discussion/todolist/templates/add_task.html
{% extends 'base.html' %}

{% block title %}Add Task{% endblock %}

{% block content %}
	<div class = "container">
		<div class = "row">
			<div class = "col-6 offset-3">
				{% if error == True %}
					<p class = "text-danger">Duplicate Task Found!</p>
				{% endif %}
				<form action="{% url 'todolist:add_task' %}" method="POST">
					
					{% csrf_token %}

					<div class="mb-3">
					    <label for="task_name">Task Name: </label>
					    <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
					</div>

					<div class="mb-3">
					    <label for="description">Description: </label>
					    <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
					</div>

					<div class="text-center">
				    	<input class="btn btn-success" type="submit" value="Add Task">
					</div>

				</form>
			</div>
		</div>
	</div>


{% endblock %}

discussion/todolist/templates/change_password.html
{% if is_user_authenticated == False %}
	<h1>Invalid User Credentials!</h1>
	<p>Check if the username and password is correct!</p>
{% else %}
	<h1>User password successfully updated!</h1>
	<p>The password has been successfully updated!</p>

{% endif %}

discussion/todolist/templates/event.html
{%extends "base.html" %}

{%block title %} My Events {% endblock %}

{% block content %}
	<div class="text-center mt-4">
		<h1>{{event_name}}</h1>

		<h3 class="mt-3">Description: </h3>
		<p>{{description}}</p>

		<h3>Status: </h3>
		<p>{{status}}</p>

		<button class = "btn btn-warning mx-1">
			<a class="text-decoration-none" href = "{% url 'todolist:index' %}">Go Back!</a>
		</button>
	</div>

{% endblock %}

discussion/todolist/templates/index.html
{% extends 'base.html' %}

{% block title %} Home {% endblock%}

{% block content %}
<div class="text-center my-4">
    {% if user.is_anonymous == False %}
    <h1 class="mt-3">Welcome {{user.first_name}}!</h1>
    {% endif %}
    {% if todoitem_list and event_list and user.is_anonymous == False %}
    <div class="text-center my-5">
        <div class="container">
            <h3 class="text-center">My Tasks</h3>
            <div class="row">
                <ul class="text-center col-lg-4 offset-lg-4 list-group mb-5">
                    {% for todoitem in todoitem_list %}
                        <li class="list-group-item"><a href = "{% url 'todolist:viewtodoitem' todoitem.id %}" class="text-decoration-none text-black">{{todoitem.task_name}}</a></li>
                    {% endfor%}    
                </ul>
            </div>
        </div>
        <div class="container">
            <h3 class="text-center mt-5">My Events</h3>
            <div class="row">
                <ul class="text-center col-lg-4 offset-lg-4 list-group">
                    {% for event in event_list %}
                        <li class="list-group-item"><a href = "{% url 'todolist:viewevent' event.id %}" class="text-decoration-none text-black">{{event.event_name}}</a></li>
                    {% endfor%}    
                </ul>
            </div>
        </div>
    </div>
        
    {% elif todoitem_list.count == 0 and user.is_anonymous == False %}
    <div class="text-center my-5">
        <h3 class="text-center mb-3">My Tasks</h3>
        <p>No tasks have been created.</p>
    </div>
        {% if event_list.count == 0 %}
        <div class="container">
            <h3 class="text-center mb-3">My Events</h3>
            <p>No events have been created.</p>
        </div>
        {% else %}
        <div class="container">
            <h3 class="text-center mb-3">My Events</h3>
            <div class="row">
                <ul class="text-center col-lg-4 offset-lg-4 list-group">
                    {% for event in event_list %}
                        <li class="list-group-item"><a href = "{% url 'todolist:viewevent' event.id %}" class="text-decoration-none text-black">{{event.event_name}}</a></li>
                    {% endfor%}    
                </ul>
            </div>
        </div>
        {% endif%}
     {% elif event_list.count == 0 and user.is_anonymous == False %}
    <div class="text-center my-5">
        {% if todoitem_list.count == 0 %}
        <h3 class="text-center mb-3">My Tasks</h3>
        <p>No tasks have been created.</p>
        {% else %}
        <div class="container">
            <h3 class="text-center mb-3">My Tasks</h3>
            <div class="row">
                <ul class="text-center col-lg-4 offset-lg-4 list-group">
                    {% for todoitem in todoitem_list %}
                        <li class="list-group-item"><a href = "{% url 'todolist:viewtodoitem' todoitem.id %}" class="text-decoration-none text-black">{{todoitem.task_name}}</a></li>
                    {% endfor%}    
                </ul>
            </div>
        </div>
        {% endif%}
    </div>
    <div class="container text-center">
        <h3 class="text-center mb-3">My Events</h3>
        <p >No events have been created.</p>
    </div>
        
    {%else%}
        <h1 class="text-center my-5">You are not authorized to access this page.</h1>
        <p class="text-center my-5">Kindly login <a href = "{% url 'todolist:login' %}">here</a>.</p>
    {% endif %}
</div>

{% endblock  %}

discussion/todolist/templates/login.html
{% extends "base.html" %}

{% block title %}Login{% endblock %}

{% block content %}
	<h1 class = "text-center my-3">Login Form</h1>
	<div class = "container">
		<div class = "row">
			<div class = "col-6 offset-3">

				{% if error == True %}
					<p class = "text-danger">Invalid credentials, please check your username and password or register first</p>
				{% endif %}
				
				<form action = "{% url 'todolist:login' %}" method = "POST">
					<!-- This template tag provides protection against Cross Site Request Forgeries (CSRF) -->
					<!-- CSRF occurs when a malicious website contains link, a from button or some javascript that is intended to perform some action in our website -->
					{% csrf_token %}
				  <div class="mb-3">
				    <label for="username" class="form-label">Username:</label>
				    <input 
				    	type="text" 
				    	class="form-control" 
				    	id="username" 
				    	value = "{{ username }}"
				    	name = "username"
				    	maxlength = "20"
				    	required 
				    	>
				  </div>
				  <div class="mb-3">
				    <label for="password" class="form-label">Password:</label>
				    <input 
				    	type="password" 
				    	class="form-control" 
				    	id="password"
				    	name = "password"
				    	value = "{{ password }}"
				    	maxlength="20" 
				    	required
				    	>

				  </div>
				  
				  <button type="submit" class="btn btn-primary">Login</button>
				</form>
				
			</div>
			
		</div>
	</div>

{% endblock %}

discussion/todolist/templates/register.html
{%extends "base.html"%}

{%block title%}Register{%endblock%}

{%block content%}

<h1 class = "text-center my-3">Registration Form</h1>
	<div class = "container">
		<div = class="row">
			<div class = "col-6 offset-3">

				{% if is_user_registered == True %}
					<p class = 'text-center text-danger my-2'>Username Already Taken!</p>
				{% endif %}

				{% if successful == True %}
					<p class = 'text-center text-success my-2'>Account Succesfully Created!</p>
				{% endif %}

				<form action = "{% url 'todolist:register' %}" method = "POST">
					
					{% csrf_token %}
				  <div class="mb-3">
				    <label for="username" class="form-label">Username:</label>
				    <input 
				    	type="text" 
				    	class="form-control" 
				    	id="username" 
				    	value = "{{ username }}"
				    	name = "username"
				    	maxlength = "50"
				    	required>
				  </div>

				  <div class="mb-3">
				    <label for="first_name" class="form-label">First Name:</label>
				    <input 
				    	type="text" 
				    	class="form-control" 
				    	id="first_name" 
				    	value = "{{ first_name }}"
				    	name = "first_name"
				    	maxlength = "50"
				    	required>
				  </div>

				   <div class="mb-3">
				    <label for="last_name" class="form-label">Last Name:</label>
				    <input 
				    	type="text" 
				    	class="form-control" 
				    	id="last_name" 
				    	value = "{{ last_name }}"
				    	name = "last_name"
				    	maxlength = "50"
				    	required>
				  </div>

				  <div class="mb-3">
				    <label for="email" class="form-label">Email:</label>
				    <input 
				    	type="text" 
				    	class="form-control" 
				    	id="email" 
				    	value = "{{ email }}"
				    	name = "email"
				    	maxlength = "50"
				    	required>
				  </div>

				  <div class="mb-3">
				    <label for="password" class="form-label">Password:</label>
				    <input 
				    	type="password" 
				    	class="form-control" 
				    	id="password"
				    	name = "password"
				    	value = "{{ password }}"
				    	maxlength="50" 
				    	required>
				  </div>

				  <div class="mb-3">
				    <label for="confirm_password" class="form-label">Confirm Password:</label>
				    <input 
				    	type="check_password" 
				    	class="form-control" 
				    	id="check_password"
				    	name = "check_password"
				    	value = "{{ confirm_password }}"
				    	maxlength="50" 
				    	required>
				  </div>

				  <div class="text-center">
				  	<button type="submit" class="btn btn-success">Register</button>
				  </div>
				  
				</form>
				
			</div>	
		</div>
	</div>

{%endblock%}

<!-- {% if is_user_registered == False %}
	<h1>User Successfully Created!</h1>

	<p>The account for {{first_name}} {{last_name}} has been succesfully created!</p>
{% else%}

	<h1>Duplicate User Found!</h1>
	<p>A duplicate user has been found, user creation unsuccessful</p>
{% endif %} -->

discussion/todolist/templates/todoitem.html
{% extends "base.html" %}

{% block title %}My Tasks{% endblock %}

{% block content %}
	<div class = "text-center mt-3">
		<h1>{{task_name}}</h1>

		<h3>Description:</h3>
		<p>{{description}}</p>

		<h3>Status:</h3>
		<p>{{status}}</p>

		<button class = "btn btn-success mx-1">
			<a class= "text-decoration-none" href = "{% url 'todolist:update_task' id%}">Edit this task!</a>
		</button>

		<button class = "btn btn-danger mx-1">
			<a class= "text-decoration-none" href = "{% url 'todolist:delete_task' id %}">Delete this task!</a>
		</button>

		<button class = "btn btn-warning mx-1">
			<a class= "text-decoration-none"href = "{% url 'todolist:index' %}">Back to Homepage!</a>
		</button>

	</div>
	
{% endblock %}

discussion/todolist/templates/update_task.html
{% extends "base.html" %}

{% block title %}Update Task{% endblock %}

{% block content %}
	{% if user.is_anonymous == False %}
		<div class = "container">
			<div class = "row">
				<div class = "col-6 offset-3">
					<h1 class = "text-center mt-3">Update Task!</h1>

					{% if error == True %}
						<p class = "text-danger text-center">Task not found!</p>
					{% endif %}
					<form action="{% url 'todolist:update_task' todoitem_id %}" method="POST">
						{% csrf_token %}

						<div class="mb-3">
						    <label for="task_name">Task Name: </label>
						    <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
						</div>

						<div class="mb-3">
						    <label for="description">Description: </label>
						    <textarea class="form-control" name="description" required>{{ description }}</textarea>
						</div>

						<div class="mb-3">
						    <label for="status">Status: </label>
						    <input class="form-control" id="status" type="text" name="status" value="{{ status }}" maxlength="50" required>
						</div>

						<div class="text-center">
					    	<input class="btn btn-success" type="submit" value="Update Task">
						</div>

					</form>
				</div>
				
			</div>
		</div>
	{% endif %}

{% endblock %}